module States

where

data BasicState =
    PBSNoBall
  | PBSInPossession
  | PBSStunned
  | PBSKickingOff
  | PBSThrowingIn
  | PBSKickingCorner
  | PBSPrepareThrowIn
 deriving (Show, Eq)

data TacticalState =
    TSNonAI
  | TSNonAIKickingOff
  | TSWaiting
  | TSCovering
  | TSPositioning
  | TSInterceptBall
  | TSHoldingPosition
  | TSMovingToThrowIn
  | TSAimingThrowIn
  | TSWaitingForKickOff
  | TSFrozen
  | TSKickingTowards
  | TSTendingGoal
  | TSGoalieWaitingForKickOff
 deriving (Show, Eq)

data BallState =
    BSFree
  | BSControlled
  | BSChallenged
  | BSOutOfPlay
  | BSControlledOOP
  | BSControlledGoalie
 deriving (Show, Eq)

data GameState =
    GSGoal
  | GSFrozen
  | GSSideOut
  | GSBaseOut
  | GSThrowIn
  | GSCorner
  | GSKickOff
  | GSRunning
  | GSQuit
 deriving (Show, Eq)
